package tc65com2tcp;

/*import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;*/

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import com.siemens.icm.io.ATCommand;
import com.siemens.icm.io.ATCommandFailedException;


public class Main extends MIDlet {

	public static final boolean DebugInfoToCOM = false; //_DEBUG
	
	ATCommand		atCommand; //       .
	Tc65SerialPort	tc65SerialPort;
	Io		io;
	MenuSettings	menuSetting;
	Tc65SocketConnection socketConnection;
	/**
	 * 
	 */
	public Main() {
		try
		{
			atCommand = new ATCommand(false);
			
			tc65SerialPort = new Tc65SerialPort();
//			tc65SerialPort.serialOut("\n\rStarting...\n\r");
			serialOut("\n\rStarting tc65com2tcp app..."+ "(build 100424)" + "\n\r" );

			io = new Io();
			
			menuSetting = new MenuSettings(tc65SerialPort, atCommand, io);

			// socketConnection  
			menuSetting.start();
			
		}
		catch(Exception e) 
		{
			System.out.println(e);
			notifyDestroyed();
		}
	}

	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		System.out.println("destroyApp(" + arg0 + ")");

        notifyDestroyed();    

	}

	protected void pauseApp() {

	}
	/**
	 * Wrappers for debug output to serial port
	 * @param str
	 */
	void serialOut(String str)
	{
		tc65SerialPort.serialOut(str.getBytes());
	}
	void serialOut(byte[] ar)
	{
		tc65SerialPort.serialOut(ar);
	}
	void DebugOut(String str)
	{
		if(menuSetting.DebugInfoToCOM)
			tc65SerialPort.serialOut(str.getBytes());
	}
	void DebugOut(byte[] ar)
	{
		if(menuSetting.DebugInfoToCOM)
			tc65SerialPort.serialOut(ar);
	}


	protected void startApp() throws MIDletStateChangeException {
		// ,    
		io.Out(0, false);
		
		// ,   
		do
		{
        	try
        	{
        	Thread.sleep(1000);
        	}
        	catch(Exception e)
        	{
        		serialOut(e.toString());
        	}
		}
		while(menuSetting.isAlive());

 		DebugOut("Menu finished, continuing\n\r");
		
		if(menuSetting.RetCode == menuSetting.MS_EXITPROG)
		{
			DebugOut("Exiting program...\r\n");
			destroyApp(true);
		}
			
		if(menuSetting.PinWasEntered == false)
		{
			//  PIN.   - .
			if(EnterPIN() == false)
			{
				DebugOut("Error entering PIN, exiting app...\n\r");
		        destroyApp(true);
			}
		}
		serialOut("\n\rSetting serial port baudrate to " + Integer.toString(menuSetting.BaudRate) + "\n\r" );
		//  -   
		tc65SerialPort.SetBaudRate(menuSetting.BaudRate);
		
		socketConnection = new Tc65SocketConnection(tc65SerialPort);
		
		byte ar[] = new byte[2048]; //    
		int pos = 0; //   
		
		boolean bExit = false;
        while(bExit == false)
        {
        	//    ,  
        	//      
        	try{atCommand.send("ATE1&C1&D0&S0X4Q0S0=1V1\r");}
    		catch(ATCommandFailedException e){}
        	
        	try
        	{
        	Thread.sleep(5000);
        	}
        	catch(Exception e)
        	{
        		DebugOut(e.toString());
        	}
        	
        	DebugOut("*g*");
        	
      		//  
       		SetupConnection();
	        		
    		// 
    		boolean bConnected = socketConnection.Connect();
    		//  ,   
    		if(bConnected == true)
    		{
       			io.Out(0, true);
               	DebugOut("*G*");
    		}
    		else
    		{
       			io.Out(0, false);
    			continue;
    		}
       		//    
   			int KeepaliveCount = 0;
   			int IncomingDataTimer = 0; //      .
   			int IncomingKeepaliveTimer = 0; //     
   			boolean bPreviousByteWasFF = false; //     
       		while(socketConnection.IsConnected())
       		{
       			boolean Stop = false;
       			
       			KeepaliveCount++;
       			IncomingKeepaliveTimer++;
	        			
   				pos = 0;
   				//   -     
				while(tc65SerialPort.hasData() > 0)
				{
					int j = tc65SerialPort.readByte();
					if(j != -1 /*&& CanSend == true*/)
					{
						byte b = (byte)(j);
						ar[pos]=b;
						pos++;

						//  ff,  2 .
						if(j == menuSetting.KeepaliveByte)
						{
    						ar[pos]=b;
    						pos++;
    						DebugOut("*FF*");
						}
//            					socketConnection.writeByte(b);
					}
				}
				if(pos > 0)
				{
					socketConnection.write(ar, pos);
					KeepaliveCount = 0;
				}
	        				
				//  
				if(KeepaliveCount > 400)  // 400   20 
				{
					KeepaliveCount = 0;
					if(menuSetting.UseKeepalives == true)
						socketConnection.writeByte((byte)menuSetting.KeepaliveByte);
					DebugOut("*K*");
				}
				else if(KeepaliveCount > 1)
				{
					//  ,     while()   .
					//  KeepaliveCount   0 
					try {
						Thread.sleep(50);
					} catch (Exception e) {
		        		DebugOut(e.toString());
					}
				}
	        				
				//       ,  .  
				int len = socketConnection.hasData();
				
				if(len <= 0)
				{
					//  ,  50     .
        			IncomingDataTimer++;
		        	try
		        	{
		        	Thread.sleep(50);
		        	}
		        	catch(Exception e)
		        	{
		        		DebugOut(e.toString());
		        	}
				}
				else
				{
        			IncomingDataTimer = 0;
					DebugOut("*s"+Integer.toString(len)+"*");
				}

				while(len > 0)
				{
					int j = socketConnection.readByte();
					boolean bProceed = true;
					if(j<0)
						bProceed = false;
					else
						IncomingDataTimer = 0;

					// ,     0xYZ,    0xYZ, 
					//    0xYZYZ,   .
					
					if(j != menuSetting.KeepaliveByte) //   -  ff,   
					{
						bPreviousByteWasFF = false;
						IncomingKeepaliveTimer = 0;
					}
					
					if(menuSetting.UseKeepalives == true && j == menuSetting.KeepaliveByte)
					{
						//    FF   ?
						if(bPreviousByteWasFF == true && IncomingKeepaliveTimer > 100)
						{
							// ,     FF
							bPreviousByteWasFF = true; //    .
							IncomingKeepaliveTimer = 0; //  
							bProceed = false;
						}	        						
						//   -  FF?
						else if(bPreviousByteWasFF == false) 
						{
							// ,     FF
							bPreviousByteWasFF = true; // ,   FF
							IncomingKeepaliveTimer = 0; //  
							bProceed = false; //  
						}
						else if(bPreviousByteWasFF == true && IncomingKeepaliveTimer <= 100)
						{
							//     FF - ,     
							bPreviousByteWasFF = false; 
							bProceed = true;
						}
						
					}
					if(bProceed == true)
					{
						tc65SerialPort.writeByte((byte)j);
    		        	//  2 -  ...   65   2 -.
						try
    		        	{
    		        	Thread.sleep(3);
    		        	}
    		        	catch(Exception e)
    		        	{
    		        		DebugOut(e.toString());
    		        	}
					}

					// ,    -  .  -  .
					len = socketConnection.hasData();
				}
	        			
//       -      .
//    ,     ( ) -
//      ! 

    			if(IncomingDataTimer > 1200) // 50  * 1200 = 60 
    			{
					DebugOut("*S("+Integer.toString(IncomingDataTimer)+")["+
							Integer.toString(IncomingKeepaliveTimer)+"]*");
    				Stop = true;
    			}
    			if(Stop == true)
    				break;
       		}
    		//   
    		socketConnection.Disconnect();
			io.Out(0, false);
			DebugOut("*D*");
        }
        
        //  ,     .
        
		//  -   115200
        serialOut("\n\rDestroying...\n\r");
        
		io.Out(0, false); // off

		destroyApp(true);
	}

	boolean EnterPIN()
	{
		boolean bOkFound = false;
		
		if(menuSetting.PINCode.length() == 0)
		{
			DebugOut("PIN empty, will not be sent.\n\r" );
			return true;
		}
		
		//     -    (  ).
		//      .
		char ar[] = menuSetting.PINCode.toCharArray();
		boolean bIsNotPin = false;
		for(int i=0; i<menuSetting.PINCode.length(); i++)
		{
			if(ar[i] < '0' || ar[i] > '9')
				bIsNotPin = true;
		}
		if(bIsNotPin == true)
		{
			DebugOut("PIN is " + menuSetting.PINCode + "(not a PIN), will not be sent.\n\r" );
			return true;
		}
		
		DebugOut("PIN=" + menuSetting.PINCode + "\r\n" );
		String s = new String("(no command has been sent)");
		try{
		s = atCommand.send("AT+CPIN=" + menuSetting.PINCode + "\r");
		}
		catch(ATCommandFailedException e)
		{
			serialOut("Exception " + e.getMessage() + "\n\r" );
		}
		DebugOut("\r\nCommand:" + s + "\n\r" );
		
		if(s.indexOf("OK") > 0)
			bOkFound = true;
		
		return bOkFound;
	}
	
	void SetupConnection()
	{
		socketConnection.SetConnType(/*bConnType*/io.CONN_TYPE_GPRS);

		socketConnection.setAPN(menuSetting.szAPN);
		socketConnection.setURL(menuSetting.szAddressToConnectTo);
		socketConnection.setPort(menuSetting.PortToConnectTo);

		socketConnection.setUsername(menuSetting.szUsername);
		socketConnection.setPassword(menuSetting.szPassword);
	}
}
