package testHTTP;

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import javax.microedition.io.ContentConnection;
import java.io.DataInputStream;

import com.siemens.icm.io.ATCommand;


public class TestHTTP extends MIDlet {

	ATCommand		atCommand; 
	Tc65SerialPort	tc65SerialPort;
	String 			strAPN;		// Sometimes APN needs to be set using AT command
	String 			strUrl;
	String 			strParams; // if we are sending params in a separate line
	
	/********************************************************
	 * Тело программы (точка входа) 
	 ********************************************************/
	public TestHTTP() {
		try
		{
	        atCommand = new ATCommand(false);
	        tc65SerialPort = new Tc65SerialPort();
	        strUrl = new String();
	        strParams = new String();
	        strAPN = new String();
	        serialOut("TestHTTP build 120211 SMTK R3\n\r");
	        serialOut("If you get \"class java.io.IOException : Profile could not be activated\" message" +
	        		" it can mean you need to enter proper APN.\r\n");
		}
		catch(Exception e) 
		{
			System.out.println(e);
			notifyDestroyed();
		}
	}

	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		System.out.println("destroyApp(" + arg0 + ")");

        notifyDestroyed();    

	}

	protected void pauseApp() {

	}
	/**
	 * Wrappers for debug output to serial port
	 * @param str
	 */
	void serialOut(String str)
	{
		tc65SerialPort.serialOut(str.getBytes());
	}
	void serialOut(byte[] ar)
	{
		tc65SerialPort.serialOut(ar);
	}
	void serialOut(char c)
	{
		tc65SerialPort.serialOut(c);
	}
	void DebugOut(String str)
	{
		tc65SerialPort.serialOut(str.getBytes());
	}
	void DebugOut(byte[] ar)
	{
		tc65SerialPort.serialOut(ar);
	}

	void ShowMenu()
	{
		serialOut("Menu\r\n");
		serialOut("U: enter URL to connect to\r\n");
		serialOut("P: enter params to connect to\r\n");
		serialOut("H: connect (HTTP) and print response\r\n");
		serialOut("C: connect (content) and print response\r\n");
		serialOut("A: enter APN and select it (needed by some operators)\r\n");
		serialOut("Q: exit\r\n");
		serialOut("Enter: show this help\r\n");
	}

	protected void startApp() throws MIDletStateChangeException {

 		DebugOut("Applet loaded\n\r");
 		
		boolean bExit = false;

		StringBuffer sbInputString = new StringBuffer(128);

		int State = 0; 

		ShowMenu();
		
		while(bExit == false)
        {
        	// Talk to terminal connected to modem's COM port
			while(tc65SerialPort.hasData() > 0)
			{
				char c = (char)tc65SerialPort.readByte();
			
				if(State > 0)
				{
					if(c == 13) // Enter
					{
						switch(State)
						{
						case 1:
							strUrl = sbInputString.toString();
							serialOut("\r\nNew URL: " + 
									strUrl + "\r\n");
							break;
						case 2:
							strParams = sbInputString.toString();
							serialOut("\r\nNew params: " + 
									strParams + "\r\n");
							break;
						case 3:
							strAPN = sbInputString.toString();
							serialOut("\r\nNew APN: " + 
									strAPN + "\r\n");
							String s = new String("response");
							try
							{
								s = atCommand.send("AT^SJNET=\"gprs\",\"" + 
										strAPN + 
										"\",\"\",\"\",\"\",30\r\n");
								serialOut("\r\nSetting APN: " + s + "\r\n");
							}
							catch(Exception e)
							{
				            	serialOut( "Excp (atCommand.send()): " + e.getClass() + " : " + e.getMessage() + "\r\n");
							}
							break;
						}
						State = 0;
					}
					else
					{
						sbInputString.append(c);
						serialOut(c);
					}
				} // State > 0
				else
				{
					switch(c)
					{
					case 'U': case 'u':
						sbInputString = new StringBuffer(128); 
						serialOut("Enter new URL: ");
						State = 1;
						break;
					case 'P': case 'p':
						sbInputString = new StringBuffer(128); 
						serialOut("Enter new params string: ");
						State = 2;
						break;
					case 'Q': case 'q':
						bExit = true;
						break;
					case 'A': case 'a':
						sbInputString = new StringBuffer(128); 
						serialOut("Enter new APN: ");
						State = 3;
						break;
					case 'H': case 'h':
						DoHTTPConnection();
						break;
					case 'C': case 'c':
						DoContentConnection();
						break;
					case 13:
						ShowMenu();
						break;
					}
				}

			}
        }
        
        DebugOut("\n\rDestroying...\n\r");
		tc65SerialPort.Close();
		destroyApp(true);
	}

	public void DoHTTPConnection()
	{
        HttpConnection conn = null;
        InputStream is = null;
        OutputStream os = null;
        try { 
            serialOut( "\r\nHTTP (POST)\r\nCalling Connector.open(" + strUrl + ")...\r\n" );
            conn = (HttpConnection) Connector.open( strUrl );
            serialOut( "\r\nCalling conn.setRequestMethod()...\r\n" );
            conn.setRequestMethod( HttpConnection.POST );
            conn.setRequestProperty( "Content-Type", "application/x-www-form-urlencoded" );

            serialOut( "\r\nCalling conn.openOutputStream()...\r\n" );
            os = conn.openOutputStream();
            if(strParams.length() > 0)
            {
                serialOut( "\r\nCalling os.write()...\r\n" );
            	os.write( strParams.getBytes() );
            }
 
            serialOut( "\r\nCalling conn.getResponseCode()...\r\n" );
            serialOut( "\r\nResponse code : " + conn.getResponseCode() + "\r\n" );
 
            serialOut( "\r\nCalling conn.openInputStream()...\r\n" );
            is = conn.openInputStream();
            int ch;
            serialOut( "\r\nServer says: \r\n" );
            while ( (ch = is.read()) != -1 )
            	serialOut( (char) ch );
            serialOut( "\r\nThis is end of what server said.\r\n" );
 
        } catch ( Exception ex ) {
        	serialOut( "Excp: " + ex.getClass() + " : " + ex.getMessage() + "\r\n");
        } 
        finally {
            try {
                if ( conn != null )
                    conn.close();
                if ( is != null )
                    is.close();
                if ( os != null )
                    os.close();
            } catch ( Exception ex ) {
            	serialOut( "Excp (close): " + ex.getClass() + " : " + ex.getMessage() + "\r\n");
            }
        }
    }	

	public void DoContentConnection()
	{
        ContentConnection conn = null;
        DataInputStream dis = null;

        try { 
            serialOut( "\r\nContentConnection\r\nCalling Connector.open(" + strUrl + ")...\r\n" );
            conn = (ContentConnection) Connector.open( strUrl );

            serialOut( "\r\nCalling Connector.getLength()... " );
            int len = (int)conn.getLength();
            serialOut( "getLength() = " + Integer.toString(len) +"\r\n" );
           
            serialOut( "\r\nCalling conn.openInputStream()...\r\n" );
            dis = conn.openDataInputStream();

            serialOut( "\r\nServer says: \r\n" );
            if (len > 0) 
            {
                byte[] data = new byte[len];
                dis.readFully(data);
                serialOut(data);
            } 
            else 
            {
                int ch;
                while ( (ch = dis.read()) != -1 )
                	serialOut( (char) ch );
            }
            serialOut( "\r\nThis is end of what server said.\r\n" );
 
        } catch ( Exception ex ) {
        	serialOut( "Excp: " + ex.getClass() + " : " + ex.getMessage() + "\r\n");
        } 
        finally {
            try {
                if ( conn != null )
                    conn.close();
                if ( dis != null )
                    dis.close();
            } catch ( Exception ex ) {
            	serialOut( "Excp (close): " + ex.getClass() + " : " + ex.getMessage() );
            }
        }
    }	
}
